/*-------------------------------------------------------------------------*/
/*                   tickerEvent header class declaration                  */
/*-------------------------------------------------------------------------*/
/*                    Ni-MH charger project US191 IRD                      */
/*-------------------------------------------------------------------------*/
/*                       Nov 2012 | J Grelet                               */
/*-------------------------------------------------------------------------*/

#ifndef tickerEvent_H
#define tickerEvent_H

#include "mbed.h"

class tickerEvent
{
private:
    Ticker     _ticker;
    DigitalOut _pin;

public:
    // Constructor
    tickerEvent(PinName pin, float delay);

    // Destructor
    ~tickerEvent(void);

    // return pin status
    int read(void);

    // A shorthand for read()
    operator int() {
        return read();
    }

private:
    // method that change pin status
    void toDo(void);

};

#endif // tickerEvent_H